<script lang="ts">
  import { getContext } from "svelte";
  import type { Download } from "../download";

  export let download: Download;
  const {
    handlePause,
    handleResume,
    handleCancel,
    handleCancelAndDelete,
    handleRemove,
    handleRemoveAndDelete,
  } = getContext("actionEvents");

  function onPause(url: string) {
    handlePause(url);
  }

  function onResume(url: string) {
    handleResume(url);
  }

  function onCancel(url: string) {
    handleCancel(url);
  }

  function onCancelAndDelete(url: string) {
    handleCancelAndDelete(url);
  }

  function onRemove(url: string) {
    handleRemove(url);
  }

  function onRemoveAndDelete(url: string) {
    handleRemoveAndDelete(url);
  }
</script>

<div class="col-12 py-3 border-bottom download-item">
  <div class="row g-2">
    <!-- URL and filename -->
    <div class="col-12">{download.url} → {download.filename}</div>

    <!-- Progress bar -->
    <div class="col-12 d-flex align-items-center">
      <div class="progress flex-grow-1 me-2">
        <div
          class="progress-bar"
          class:bg-success={download.ended}
          class:bg-secondary={download.paused}
          role="progressbar"
          style="width: {download.progress}%">
          {download.progress}%
        </div>
      </div>

      {#if !download.ended}
        <!-- Pause/Resume button -->
        <div class="me-2">
          {#if download.paused}
            <button
              class="btn btn-outline-primary btn-sm"
              on:click={() => onResume(download.url)}><i
                class="bi bi-play-circle" />
              Resume</button>
          {:else}
            <button
              class="btn btn-outline-primary btn-sm"
              on:click={() => onPause(download.url)}><i
                class="bi bi-pause-circle" />
              Pause</button>
          {/if}
        </div>

        <!-- Cancel dropdown -->
        <div class="dropdown">
          <button
            class="btn btn-outline-danger btn-sm dropdown-toggle"
            type="button"
            data-bs-toggle="dropdown">
            <i class="bi bi-stop-circle" />
            Cancel
          </button>
          <ul class="dropdown-menu small">
            <li>
              <a
                class="dropdown-item"
                href={'#'}
                on:click={() => onCancel(download.url)}><i
                  class="bi bi-stop-circle" />
                Cancel</a>
            </li>
            <li>
              <a
                class="dropdown-item"
                href={'#'}
                on:click={() => onCancelAndDelete(download.url)}><i
                  class="bi bi-x-circle" />
                Cancel and delete file</a>
            </li>
          </ul>
        </div>
      {:else}
        <!-- Remove dropdown -->
        <div class="dropdown">
          <button
            class="btn btn-outline-danger btn-sm dropdown-toggle"
            type="button"
            data-bs-toggle="dropdown">
            <i class="bi bi-stop-circle" />
            Remove
          </button>
          <ul class="dropdown-menu small">
            <li>
              <a
                class="dropdown-item"
                href={'#'}
                on:click={() => onRemove(download.url)}><i
                  class="bi bi-stop-circle" />
                Remove</a>
            </li>
            <li>
              <a
                class="dropdown-item"
                href={'#'}
                on:click={() => onRemoveAndDelete(download.url)}><i
                  class="bi bi-x-circle" />
                Remove and delete file</a>
            </li>
          </ul>
        </div>
      {/if}
    </div>

    <div class="col-3">
      {download.formatCompleted()}
      of
      {download.formatSize()}
    </div>
    {#if !download.paused && !download.ended}
      <div class="col-6 text-center">{download.formatSpeed()}</div>
      <div class="col-3 text-end">{download.formatRemaining()}</div>
    {/if}
  </div>
</div>
